class UR_PlayerController extends UTPlayerController;

enum PlayerClass
{
	eSurfer,
	eStealth,
	eAkimbo
};

enum PlayerWeapon
{
	eSniper,
	eLink,
	eRox,
	eHammer
};

enum PlayerKit
{
	eSlowField,
	eShield,
	eLandMine,
	eSkyMine
};

struct PlayerDetails
{
	var PlayerClass PlayerClass;
	var PlayerWeapon PlayerWeapon;
	var PlayerKit PlayerKit;
	var int ArmourRatio, ColourData;
	var LinearColor EffectsColour;
};

var PlayerDetails PlayerSelection;
var Material StealthMaterial, SpeedOverlay;

simulated function SetAndRespawnPlayer()
{
	Pawn.InvManager.DiscardInventory();
	
	UR_Pawn(Pawn).VestArmor = 0;
	UR_Pawn(Pawn).HelmetArmor = 0;
	UR_Pawn(Pawn).ThighpadArmor = 0;
	UR_Pawn(Pawn).ShieldBeltArmor = 0;

	switch(PlayerSelection.PlayerClass)
	{
		case eSurfer:
			Pawn.Health = 100;
			Pawn.HealthMax = 100;
			UR_Pawn(Pawn).SuperHealthMax = 199;
			Pawn.GroundSpeed = 450;
			Pawn.WaterSpeed = 300;
			Pawn.AirSpeed = 400;
			Pawn.JumpZ = 400;
			UR_Pawn(Pawn).SetInvisible(false);
			UR_Pawn(Pawn).SetSkin(none);
			
			if (PlayerSelection.ArmourRatio == 0)
			{
				Pawn.GroundSpeed += 50;
				Pawn.WaterSpeed += 50;
				Pawn.AirSpeed += 50;
				Pawn.JumpZ += 25;
				break;
			}
			else if (PlayerSelection.ArmourRatio == 1)
			{
				Pawn.GroundSpeed += 25;
				Pawn.WaterSpeed += 25;
				Pawn.AirSpeed += 25;
				UR_Pawn(Pawn).VestArmor = 15;
				break;
			}
			else if (PlayerSelection.ArmourRatio == 2)
			{
				UR_Pawn(Pawn).VestArmor = 30;
				break;
			}
			else if (PlayerSelection.ArmourRatio == 3)
			{
				Pawn.GroundSpeed -= 15;
				Pawn.WaterSpeed -= 15;
				Pawn.AirSpeed -= 15;
				Pawn.JumpZ -= 15;
				UR_Pawn(Pawn).VestArmor = 45;
				UR_Pawn(Pawn).HelmetArmor = 10;
				break;
			}
			else if (PlayerSelection.ArmourRatio == 4)
			{
				Pawn.GroundSpeed -= 30;
				Pawn.WaterSpeed -= 30;
				Pawn.AirSpeed -= 30;
				Pawn.JumpZ -= 30;
				UR_Pawn(Pawn).VestArmor = 60;
				UR_Pawn(Pawn).HelmetArmor = 20;
				break;
			}
			else if (PlayerSelection.ArmourRatio == 5)
			{
				Pawn.GroundSpeed -= 45;
				Pawn.WaterSpeed -= 45;
				Pawn.AirSpeed -= 45;
				Pawn.JumpZ -= 45;
				UR_Pawn(Pawn).VestArmor = 75;
				UR_Pawn(Pawn).HelmetArmor = 20;
				UR_Pawn(Pawn).ThighpadArmor = 10;
				break;
			}
			else if (PlayerSelection.ArmourRatio == 6)
			{
				Pawn.GroundSpeed -= 60;
				Pawn.WaterSpeed -= 60;
				Pawn.AirSpeed -= 60;
				Pawn.JumpZ -= 60;
				UR_Pawn(Pawn).VestArmor = 100;
				UR_Pawn(Pawn).HelmetArmor = 20;
				UR_Pawn(Pawn).ThighpadArmor = 20;
				break;
			}
			else if (PlayerSelection.ArmourRatio == 7)
			{
				Pawn.GroundSpeed -= 75;
				Pawn.WaterSpeed -= 75;
				Pawn.AirSpeed -= 75;
				Pawn.JumpZ -= 75;
				UR_Pawn(Pawn).VestArmor = 110;
				UR_Pawn(Pawn).HelmetArmor = 20;
				UR_Pawn(Pawn).ThighpadArmor = 20;
				break;
			}
			else
			{
				`log("Armour Allocation failed in SetAndRespawnPlayer");
			}
			
			break;
		case eStealth:
			Pawn.Health = 75;
			Pawn.HealthMax = 75;
			UR_Pawn(Pawn).SuperHealthMax = 149;
			Pawn.GroundSpeed = 340;
			Pawn.WaterSpeed = 220;
			Pawn.AirSpeed = 300;
			Pawn.JumpZ = 350;
			UR_Pawn(Pawn).SetInvisible(true);
			UR_Pawn(Pawn).SetSkin(StealthMaterial);
			
			if (PlayerSelection.ArmourRatio == 0)
			{
				Pawn.GroundSpeed += 50;
				Pawn.WaterSpeed += 50;
				Pawn.AirSpeed += 50;
				Pawn.JumpZ += 25;
				break;
			}
			if (PlayerSelection.ArmourRatio == 1)
			{
				Pawn.GroundSpeed += 25;
				Pawn.WaterSpeed += 25;
				Pawn.AirSpeed += 25;
				UR_Pawn(Pawn).VestArmor = 10;
				break;
			}
			else if (PlayerSelection.ArmourRatio == 2)
			{
				UR_Pawn(Pawn).VestArmor = 20;
				break;
			}
			else if (PlayerSelection.ArmourRatio == 3)
			{
				Pawn.GroundSpeed -= 15;
				Pawn.WaterSpeed -= 15;
				Pawn.AirSpeed -= 15;
				Pawn.JumpZ -= 15;
				UR_Pawn(Pawn).VestArmor = 30;
				UR_Pawn(Pawn).HelmetArmor = 10;
				break;
			}
			else if (PlayerSelection.ArmourRatio == 4)
			{
				Pawn.GroundSpeed -= 30;
				Pawn.WaterSpeed -= 30;
				Pawn.AirSpeed -= 30;
				Pawn.JumpZ -= 30;
				UR_Pawn(Pawn).VestArmor = 40;
				UR_Pawn(Pawn).HelmetArmor = 20;
				break;
			}
			else if (PlayerSelection.ArmourRatio == 5)
			{
				Pawn.GroundSpeed -= 45;
				Pawn.WaterSpeed -= 45;
				Pawn.AirSpeed -= 45;
				Pawn.JumpZ -= 45;
				UR_Pawn(Pawn).VestArmor = 50;
				UR_Pawn(Pawn).HelmetArmor = 20;
				UR_Pawn(Pawn).ThighpadArmor = 10;
				break;
			}
			else if (PlayerSelection.ArmourRatio == 6)
			{
				Pawn.GroundSpeed -= 60;
				Pawn.WaterSpeed -= 60;
				Pawn.AirSpeed -= 60;
				Pawn.JumpZ -= 60;
				UR_Pawn(Pawn).VestArmor = 50;
				UR_Pawn(Pawn).HelmetArmor = 25;
				UR_Pawn(Pawn).ThighpadArmor = 25;
				break;
			}
			else if (PlayerSelection.ArmourRatio == 7)
			{
				Pawn.GroundSpeed -= 75;
				Pawn.WaterSpeed -= 75;
				Pawn.AirSpeed -= 75;
				Pawn.JumpZ -= 75;
				UR_Pawn(Pawn).VestArmor = 70;
				UR_Pawn(Pawn).HelmetArmor = 25;
				UR_Pawn(Pawn).ThighpadArmor = 25;
				break;
			}
			else
			{
				`log("Armour Allocation failed in SetAndRespawnPlayer");
			}
			
			break;
		case eAkimbo:
			Pawn.Health = 125;
			Pawn.HealthMax = 125;
			UR_Pawn(Pawn).SuperHealthMax = 249;
			Pawn.GroundSpeed = 300;
			Pawn.WaterSpeed = 200;
			Pawn.AirSpeed = 200;
			Pawn.JumpZ = 300;
			UR_Pawn(Pawn).SetInvisible(false);
			UR_Pawn(Pawn).SetSkin(none);
			
			if (PlayerSelection.ArmourRatio == 0)
			{
				Pawn.GroundSpeed += 50;
				Pawn.WaterSpeed += 50;
				Pawn.AirSpeed += 50;
				Pawn.JumpZ += 25;
				break;
			}
			else if (PlayerSelection.ArmourRatio == 1)
			{
				Pawn.GroundSpeed += 25;
				Pawn.WaterSpeed += 25;
				Pawn.AirSpeed += 25;
				UR_Pawn(Pawn).VestArmor = 25;
				break;
			}
			else if (PlayerSelection.ArmourRatio == 2)
			{
				UR_Pawn(Pawn).VestArmor = 50;
				break;
			}
			else if (PlayerSelection.ArmourRatio == 3)
			{
				Pawn.GroundSpeed -= 15;
				Pawn.WaterSpeed -= 15;
				Pawn.AirSpeed -= 15;
				Pawn.JumpZ -= 15;
				UR_Pawn(Pawn).VestArmor = 50;
				UR_Pawn(Pawn).HelmetArmor = 25;
				break;
			}
			else if (PlayerSelection.ArmourRatio == 4)
			{
				Pawn.GroundSpeed -= 30;
				Pawn.WaterSpeed -= 30;
				Pawn.AirSpeed -= 30;
				Pawn.JumpZ -= 30;
				UR_Pawn(Pawn).VestArmor = 50;
				UR_Pawn(Pawn).HelmetArmor = 25;
				UR_Pawn(Pawn).ThighpadArmor = 25;
				break;
			}
			else if (PlayerSelection.ArmourRatio == 5)
			{
				Pawn.GroundSpeed -= 45;
				Pawn.WaterSpeed -= 45;
				Pawn.AirSpeed -= 45;
				Pawn.JumpZ -= 45;
				UR_Pawn(Pawn).VestArmor = 50;
				UR_Pawn(Pawn).HelmetArmor = 25;
				UR_Pawn(Pawn).ThighpadArmor = 25;
				UR_Pawn(Pawn).ShieldBeltArmor = 25;
				break;
			}
			else if (PlayerSelection.ArmourRatio == 6)
			{
				Pawn.GroundSpeed -= 60;
				Pawn.WaterSpeed -= 60;
				Pawn.AirSpeed -= 60;
				Pawn.JumpZ -= 60;
				UR_Pawn(Pawn).VestArmor = 50;
				UR_Pawn(Pawn).HelmetArmor = 25;
				UR_Pawn(Pawn).ThighpadArmor = 25;
				UR_Pawn(Pawn).ShieldBeltArmor = 50;
				break;
			}
			else if (PlayerSelection.ArmourRatio == 7)
			{
				Pawn.GroundSpeed -= 75;
				Pawn.WaterSpeed -= 75;
				Pawn.AirSpeed -= 75;
				Pawn.JumpZ -= 60;
				UR_Pawn(Pawn).VestArmor = 50;
				UR_Pawn(Pawn).HelmetArmor = 25;
				UR_Pawn(Pawn).ThighpadArmor = 25;
				UR_Pawn(Pawn).ShieldBeltArmor = 100;
				break;
			}
			else
			{
				`log("Armour Allocation failed in SetAndRespawnPlayer");
			}
			
			break;
		default:
			`log("Class selection failed in SetAndRespawnPlayer");
			break;
	}
	
	switch(PlayerSelection.PlayerWeapon)
	{
		case eHammer:
			if (PlayerSelection.PlayerClass == eAkimbo)
			{
				Weapon(Pawn.CreateInventory( class'UnrealRider.UR_Weap_Hammer_D' ));
			}
			else
			{
				Weapon(Pawn.CreateInventory( class'UnrealRider.UR_Weap_Hammer' ));
			}
			break;
		case eLink:
			if (PlayerSelection.PlayerClass == eAkimbo)
			{
				Weapon(Pawn.CreateInventory( class'UnrealRider.UR_Weap_Link_D' ));
			}
			else
			{
				Weapon(Pawn.CreateInventory( class'UnrealRider.UR_Weap_Link' ));
			}
			break;
		case eSniper:
			if (PlayerSelection.PlayerClass == eAkimbo)
			{
				Weapon(Pawn.CreateInventory( class'UnrealRider.UR_Weap_Sniper_D' ));
			}
			else
			{
				Weapon(Pawn.CreateInventory( class'UnrealRider.UR_Weap_Sniper' ));
			}
			break;
		case eRox:
			if (PlayerSelection.PlayerClass == eAkimbo)
			{
				Weapon(Pawn.CreateInventory( class'UnrealRider.UR_Weap_Rox_D' ));
			}
			else
			{
				Weapon(Pawn.CreateInventory( class'UnrealRider.UR_Weap_Rox' ));
			}
			break;
		default:
			`log("Weapon selection failed in SetAndRespawnPlayer");
			break;
	}
	
	switch(PlayerSelection.PlayerKit)
	{
		case eSlowField:
			Weapon(Pawn.CreateInventory( class'UnrealRider.UR_Deployable_SlowField' ));
			break;
		case eShield:
			Weapon(Pawn.CreateInventory( class'UnrealRider.UR_Deployable_Shield' ));
			break;
		case eLandMine:
			Weapon(Pawn.CreateInventory( class'UnrealRider.UR_Deployable_Mine' ));
			break;
		case eSkyMine:
			Weapon(Pawn.CreateInventory( class'UnrealRider.UR_Deployable_SkyMine' ));
			break;
		default:
			`log("Weapon selection failed in SetAndRespawnPlayer");
			break;
	}
}

exec function ShowClassMenu()
{
    DynamicOpenMenu("LP_UR_Assets.ClassMenu");
}

simulated function DynamicOpenMenu( string MenuPath, optional int PlayerIndex=INDEX_NONE )
{
	local UIScene Scene;
	local GameUISceneClient GS;

	GS = UTGameUISceneClient(class'UIRoot'.static.GetSceneClient());

    Scene = UIScene(DynamicLoadObject(MenuPath, class'UIScene'));
	UR_ClassMenu(Scene).PC = self;
	
	if ( !GS.OpenScene(Scene) )
	{
		`Log("Failed to load menu '" $ MenuPath $"'");
	}
}

state Dead
{
	exec function StartFire( optional byte FireModeNum )
	{
		if ( bFrozen )
		{
			if ( !IsTimerActive() || GetTimerCount() > MinRespawnDelay )
			{
				bFrozen = false;
			}
			return;
		}
		
		ServerReStartPlayer();

		if (FireModeNum == 1)
		{
			ShowClassMenu();
		}
		
		UR_Pawn(Pawn).VestArmor = 0;
		UR_Pawn(Pawn).HelmetArmor = 0;
		UR_Pawn(Pawn).ThighpadArmor = 0;
		UR_Pawn(Pawn).ShieldBeltArmor = 0;
		
		SetAndRespawnPlayer();
	}
}

reliable client function PlayStartupMessage(byte StartupStage)
{
	if ( StartupStage == 7 )
	{
		ReceiveLocalizedMessage( class'UTTimerMessage', 17, PlayerReplicationInfo );
	}
	else
	{
		ReceiveLocalizedMessage( class'UR_StartupMessage', StartupStage, PlayerReplicationInfo );
	}
}

DefaultProperties
{
	PlayerSelection = (PlayerClass = eAkimbo, PlayerWeapon = eLink, PlayerKit = eShield, ArmourRatio = 2, EffectsColour = (R=255,G=0,B=0,A=255) )
	StealthMaterial = Material'PICKUPS.Invis.M_Invis_01'
	SpeedOverlay = Material'PICKUPS.Invulnerability.M_Invulnerability_Overlay'
}