//-----------------------------------------------------------
//
//  - UnrealRider -  UR_ShieldGenerator
//  Written/tested by Erwan Allain (zall1@hotmail.com)
//
//  Shield Generator maintaining the shield enabled around the flag
//
//-----------------------------------------------------------
class UR_ShieldGenerator extends UTGameObjective
  placeable;

var(ShieldGenerator) string shieldTagName;
var bool genEnable;


/**
*  This method is dedicated to throw event when Generator has been enabled
*  or disabled.
*  Available Event Type are:
*  - disable
*  - enable
*/
function notifyShieldGeneratorEvent(name eventType)
{
	  local int i;
	  local UR_ShieldGeneratorEvent shieldGenEvent;

	  for (i = 0; i < GeneratedEvents.length; i++)
	  {
		 shieldGenEvent = UR_ShieldGeneratorEvent(GeneratedEvents[i]);
		 if (shieldGenEvent != None)
		 {
			shieldGenEvent.notifyShieldGeneratorEvent(eventType, self);
		 }
	  }
}

defaultproperties
{

  //class properties
  genEnable = false
  SupportedEvents.Empty
  SupportedEvents(0) = class'UR_ShieldGeneratorEvent'

  //parent class properties
  Begin Object Name=CollisionCylinder
		CollisionRadius=160.0
		CollisionHeight=30.0
	End Object

  Begin Object Class=StaticMeshComponent Name=StaticMeshComponent0
		StaticMesh=StaticMesh'GP_Onslaught.Mesh.S_GP_Ons_Power_Node_Base'
		CollideActors=true
		BlockActors=true
		CastShadow=true
		bCastDynamicShadow=false
		Translation=(X=0.0,Y=0.0,Z=-34.0)
		bUseAsOccluder=FALSE
	End Object
 	Components.Add(StaticMeshComponent0)

  	Begin Object class=StaticMeshComponent Name=StaticMeshSpinner
 		StaticMesh=StaticMesh'GP_Onslaught.Mesh.S_GP_Ons_Power_Node_spinners'
 		CollideActors=false
 		BlockActors=false
 		CastShadow=false
		bCastDynamicShadow=false
		Translation=(Z=-34.0)
		bUseAsOccluder=FALSE
 	End Object
 	Components.Add(StaticMeshSpinner)

	Begin Object Class=SkeletalMeshComponent Name=SkeletalMeshComponent1
		SkeletalMesh=SkeletalMesh'GP_Onslaught.Mesh.SK_GP_Ons_Power_Node_Panels'
		AnimTreeTemplate=AnimTree'GP_Onslaught.Anims.AT_GP_Ons_Power_Node_Panels'
		CollideActors=false
		BlockActors=false
		CastShadow=false
		bCastDynamicShadow=false
		bUpdateSkelWhenNotRendered=false
		bIgnoreControllersWhenNotRendered=true
		Translation=(X=0.0,Y=0.0,Z=240.0)
		Scale3D=(X=1.5,Y=1.5,Z=1.25)
		bUseAsOccluder=FALSE
		bAcceptsDecals=false
	End Object
 	Components.Add(SkeletalMeshComponent1)
}