//-----------------------------------------------------------
//
//  - UnrealRider -  UR_ShieldVolume
//  Written/tested by Erwan Allain (zall1@hotmail.com)
//
// The ShieldVolume prevents the player to reach an objective (capture the flag)
// ShieldGenerators linked to the ShieldVolume have to be disabled in order to
// disable the ShieldVolume
//
//-----------------------------------------------------------
class UR_ShieldVolume extends PhysicsVolume
  placeable;


enum ShieldState
{
 SHIELD_ENABLE, SHIELD_DISABLE
};

var(ShieldVolume) string shieldTagName;
var array<UR_ShieldGenerator> generators;
var ShieldState shState;

simulated function PostBeginPlay()
{
  local UR_ShieldGenerator UR_S;
  foreach WorldInfo.AllActors(class'UR_ShieldGenerator', UR_S)
  {
     if(UR_S.shieldTagName == shieldTagName)
     {
       generators.addItem(UR_S);
     }
  }
}

//Method call from SeqAct ===============================
function generatorChangeState(UR_ShieldGenerator generator)
{
  checkGenerators(generator);
}
//End Method call from SeqAct ===========================

function checkGenerators(UR_ShieldGenerator generator)
{
  local int i;
  local ShieldState newState;

  if(generators.find(generator) > 1)
  {
    generators[generators.find(generator)] = generator;
  }

  newState = SHIELD_DISABLE;
  for(i=0;i<generators.length;i++)
  {
    if(generators[i].genEnable)
    {
       newState = SHIELD_ENABLE;
    }
  }

  if(newState != shState)
  {
    StateChange(newState);
  }
}

function StateChange(ShieldState newState)
{
  shState = newState;

  switch(newState)
  {
     case ShieldState.SHIELD_ENABLE:
             enableShield();
             break;

     case ShieldState.SHIELD_DISABLE:
             disableShield();
             break;
  }
}

function enableShield()
{

}

function disableShield()
{

}

defaultproperties
{

}
