class UR_Weap_MegaRox extends UTWeap_RocketLauncher;

var class<Projectile> CenterRocketClass, SubRocketClass;

//We can't use CustomFire with FireModeNum, which is very annoying, so we use ProjectileFire and over-write it instead.
simulated function CustomFire()
{
	local int i,j;
   	local vector RealStartLoc, AimDir, YDir, ZDir;
	local Projectile Proj;
	local float Mag;

	IncrementFlashCount();

	if (Role == ROLE_Authority)
	{
		// this is the location where the projectile is spawned
		RealStartLoc = GetPhysicalFireStartLoc();
		// get fire aim direction
		GetAxes(GetAdjustedAim(RealStartLoc),AimDir, YDir, ZDir);

		// special center shard
		Proj = Spawn(CenterRocketClass,,, RealStartLoc);
		if (Proj != None)
		{
			Proj.Init(AimDir);
		}

		// one shard in each of 9 zones (except center)
		for ( i=-1; i<2; i++)
		{
			for ( j=-1; j<2; j++ )
			{
				if ( (i != 0) || (j != 0) )
				{
					Mag = (abs(i)+abs(j) > 1) ? 0.7 : 1.0;
					Proj = Spawn(SubRocketClass,,, RealStartLoc);
					if (Proj != None)
					{
						Proj.Init(AimDir + (0.3 + 0.7*FRand())*Mag*i*SpreadDist*YDir + (0.3 + 0.7*FRand())*Mag*j*SpreadDist*ZDir );
					}
				}
			}
	    }
	}
}

simulated function Projectile ProjectileFire()
{
	if (AmmoCount < MaxAmmoCount)
	{
		AmmoCount += 1;
	}

	return none;
}

defaultproperties
{
	WeaponFireTypes(0)=EWFT_Custom
	WeaponFireTypes(1)=EWFT_Projectile
	WeaponProjectiles(0)=class'UTProj_Rocket'//Never used.
	WeaponProjectiles(1)=class'UTProj_Rocket'//Never used.

	//CenterShardClass=class'UR_Proj_MajorRocket'
	//CenterShardClass=class'UR_Proj_MinorRocket'

	ShotCost(0)=1
	ShotCost(1)=-1
}